package speiger.src.coreengine.utils.functions;

import java.util.function.Consumer;
import java.util.function.Predicate;

public class Functions
{
	static final Predicate<Object> ALWAYS_TRUE = (T) -> true;
	static final Consumer<Object> EMPTY_CONSUMER = (T) -> {};
	public static final Predicate<String> NUMBERS_ONLY = T -> {
		if(T.isEmpty() || T.equals("#") || T.equals("0x"))
		{
			return true;
		}
		try
		{
			Integer.decode(T);
			return true;
		}
		catch(Exception e){return false;}
	};
	
	public static <T> Predicate<T> getAlwaysTrue()
	{
		return (Predicate<T>)ALWAYS_TRUE;
	}
	
	public static <T> Consumer<T> getVoidConsumer()
	{
		return (Consumer<T>)EMPTY_CONSUMER;
	}
}
